% cheese_a3conv converts output files from cheese and related programs to
% matlab's own data format. 
% 
% HG 2014-03-25

inputcheese

% Now read the probe specific data, if there are probes that is.
probe=struct();
fid=fopen('inputcheese.m');
for ii=1:Nprobes
  theline=fgetl(fid);
  if length(theline)<5,
    theline=[theline '     '];
  end
  while ~(strcmp(theline(1:5),'%PROB') | strcmp(theline(1:5),'%prob'))
    theline=fgetl(fid);
    if length(theline)<5,
      theline=[theline '     '];
    end
  end
  while ~(strcmp(theline(1:4),'%END') | strcmp(theline(1:4),'%end'))
    eval(theline)
    theline=fgetl(fid);
    if length(theline)<4,
      theline=[theline '    '];
    end
  end
  probe(ii).Nvx=Nvx;
  probe(ii).Nvy=Nvy;
  probe(ii).Nvz=Nvz;
  probe(ii).vxmin=vxmin;
  probe(ii).vxmax=vxmax;
  probe(ii).vymin=vymin;
  probe(ii).vymax=vymax;
  probe(ii).vzmin=vzmin;
  probe(ii).vzmax=vzmax;
  probe(ii).xc=xc;
  probe(ii).yc=yc;
  probe(ii).zc=zc;
  probe(ii).rprobe=rprobe;
  
  probe(ii).dvx = (vxmax-vxmin)/(Nvx-1);
  probe(ii).dvy = (vymax-vymin)/(Nvy-1);
  probe(ii).dvz = (vzmax-vzmin)/(Nvz-1);
  probe(ii).vx  = vxmin + probe(ii).dvx*[0:Nvx-1];
  probe(ii).vy  = vymin + probe(ii).dvy*[0:Nvy-1];
  probe(ii).vz  = vzmin + probe(ii).dvz*[0:Nvz-1];
end
fclose(fid);

% Hybrid species parameters
particle=struct();
fid=fopen('inputcheese.m');
for ii=1:NhybSpecies
  theline=fgetl(fid);
  if length(theline)<5,
    theline=[theline '     '];
  end
  while ~(strcmp(theline(1:5),'%SPEC') | strcmp(theline(1:5),'%spec'))
    theline=fgetl(fid);
    if length(theline)<5,
      theline=[theline '     '];
    end
  end
  while ~(strcmp(theline(1:4),'%END') | strcmp(theline(1:4),'%end'))
    eval(theline)
    theline=fgetl(fid);
    if length(theline)<4,
      theline=[theline '    '];
    end
  end
  particle(ii).hybfilename = hybfilename;
  particle(ii).chargestate = chargestate;
  particle(ii).hybiteration =hybiteration;
end
fclose(fid);

% Parameters of the grid that is used for statistical output
fid=fopen('inputcheese.m');
theline=fgetl(fid);
if length(theline)<5,
  theline=[theline '     '];
end
while ~(strcmp(theline(1:5),'%PARA') | strcmp(theline(1:5),'%para'))
  theline=fgetl(fid);
  if length(theline)<5,
    theline=[theline '     '];
  end
end
while ~(strcmp(theline(1:4),'%END') | strcmp(theline(1:4),'%end'))
  eval(theline)
  theline=fgetl(fid);
  if length(theline)<4,
    theline=[theline '    '];
  end
end
Lx=xmax-xmin;
Ly=ymax-ymin;
Lz=zmax-zmin;
dx = Lx/(Nx-1);
dy = Ly/(Ny-1);
dz = Lz/(Nz-1);
x = xmin + dx*[0:Nx-1];
y = ymin + dy*[0:Ny-1];
z = zmin + dz*[0:Nz-1];
fclose(fid);
filepath='outp/datfiles/statistics/';
dd=dir(filepath);
for ii=1:length(dd)
  if length(dd(ii).name)>14
    if strcmp(dd(ii).name(end-10:end),'.cheese.dat')
      if strcmp(dd(ii).name(1:4),'dens')
        nin = load([filepath dd(ii).name]);
        n = reshape(nin,Nx,Ny,Nz);
        eval(['save -v7 outp/testpdens' dd(ii).name(5:14) '.cheese.mat n ' ...
              'Nx Ny Nz Lx Ly Lz x y z dx dy dz'])
        delete([filepath dd(ii).name]);
      end
    end
  end
end


% Read the input grids here
fgrid=struct();
fid=fopen('inputcheese.m');
for ii=1:Ngridlevels
  theline=fgetl(fid);
  if length(theline)<5,
    theline=[theline '     '];
  end
  while ~(strcmp(theline(1:5),'%GRID') | strcmp(theline(1:5),'%grid'))
    theline=fgetl(fid);
    if length(theline)<5,
      theline=[theline '     '];
    end
  end
  while ~(strcmp(theline(1:4),'%END') | strcmp(theline(1:4),'%end'))
    eval(theline)
    theline=fgetl(fid);
    if length(theline)<4,
      theline=[theline '    '];
    end
  end
  fgrid(ii).Nx=Nx;
  fgrid(ii).Ny=Ny;
  fgrid(ii).Nz=Nz;
  fgrid(ii).xmin=xmin;
  fgrid(ii).xmax=xmax;
  fgrid(ii).ymin=ymin;
  fgrid(ii).ymax=ymax;
  fgrid(ii).zmin=zmin;
  fgrid(ii).zmax=zmax;
  
  fgrid(ii).Lx=fgrid(ii).xmax-fgrid(ii).xmin;
  fgrid(ii).Ly=fgrid(ii).ymax-fgrid(ii).ymin;
  fgrid(ii).Lz=fgrid(ii).zmax-fgrid(ii).zmin;
  fgrid(ii).dx = fgrid(ii).Lx/(fgrid(ii).Nx-1);
  fgrid(ii).dy = fgrid(ii).Ly/(fgrid(ii).Ny-1);
  fgrid(ii).dz = fgrid(ii).Lz/(fgrid(ii).Nz-1);
  fgrid(ii).x = fgrid(ii).xmin + fgrid(ii).dx*[0:fgrid(ii).Nx-1];
  fgrid(ii).y = fgrid(ii).ymin + fgrid(ii).dy*[0:fgrid(ii).Ny-1];
  fgrid(ii).z = fgrid(ii).zmin + fgrid(ii).dz*[0:fgrid(ii).Nz-1];
end
fclose(fid);


filepath='outp/datfiles/Efield/';
dd=dir(filepath);
for ii=1:length(dd)
  if length(dd(ii).name)>14
    if strcmp(dd(ii).name(end-10:end),'.cheese.dat')
      switch dd(ii).name(1:4)         
       case 'Efi_'
        E = load([filepath dd(ii).name]);
        gl=str2num(dd(ii).name(5:6));
        Ex = E(:,1);
        Ey = E(:,2);
        Ez = E(:,3); 
        Ex = reshape(Ex,fgrid(gl).Nx,fgrid(gl).Ny,fgrid(gl).Nz);
        Ey = reshape(Ey,fgrid(gl).Nx,fgrid(gl).Ny,fgrid(gl).Nz);
        Ez = reshape(Ez,fgrid(gl).Nx,fgrid(gl).Ny,fgrid(gl).Nz);
        fgrid(gl).Ex=Ex; fgrid(gl).Ey=Ey; fgrid(gl).Ez=Ez;
       % save both E and B in the grid file below. And j and n too.
       otherwise
        disp(['Nothing to do for file ' dd(ii).name])

      end
    end
  end
end

filepath='outp/datfiles/Bfield/';
dd=dir(filepath);
for ii=1:length(dd)
  if length(dd(ii).name)>14
    if strcmp(dd(ii).name(end-10:end),'.cheese.dat')
      switch dd(ii).name(1:4)         
       case 'Bfi_'
        B = load([filepath dd(ii).name]);
        gl=str2num(dd(ii).name(5:6));
        Bx = B(:,1);
        By = B(:,2);
        Bz = B(:,3); 
        Bx = reshape(Bx,fgrid(gl).Nx,fgrid(gl).Ny,fgrid(gl).Nz);
        By = reshape(By,fgrid(gl).Nx,fgrid(gl).Ny,fgrid(gl).Nz);
        Bz = reshape(Bz,fgrid(gl).Nx,fgrid(gl).Ny,fgrid(gl).Nz);
        fgrid(gl).Bx=Bx; fgrid(gl).By=By; fgrid(gl).Bz=Bz;
       % save both E and B in the grid file below. And j and n too.
       otherwise
        disp(['Nothing to do for file ' dd(ii).name])

      end
    end
  end
end

filepath='outp/datfiles/current/';
dd=dir(filepath);
for ii=1:length(dd)
  if length(dd(ii).name)>14
    if strcmp(dd(ii).name(end-10:end),'.cheese.dat')
      switch dd(ii).name(1:4)         
       case 'cur_'
        cur = load([filepath dd(ii).name]);
        gl=str2num(dd(ii).name(5:6));
        jx = cur(:,1);
        jy = cur(:,2);
        jz = cur(:,3); 
        jx = reshape(jx,fgrid(gl).Nx,fgrid(gl).Ny,fgrid(gl).Nz);
        jy = reshape(jy,fgrid(gl).Nx,fgrid(gl).Ny,fgrid(gl).Nz);
        jz = reshape(jz,fgrid(gl).Nx,fgrid(gl).Ny,fgrid(gl).Nz);
        fgrid(gl).jx=jx; fgrid(gl).jy=jy; fgrid(gl).jz=jz;
        % save both E and B in the fgrid file below. And j and n too.
       otherwise
        disp(['Nothing to do for file ' dd(ii).name])

      end
    end
  end
end

filepath='outp/datfiles/density/';
dd=dir(filepath);
for gl=1:NhybSpecies
  fgrid(gl).particle = particle;
end
for ii=1:length(dd)
  if length(dd(ii).name)>14
    if strcmp(dd(ii).name(end-10:end),'.cheese.dat')
      switch dd(ii).name(1)         
       case 'n'
        nin = load([filepath dd(ii).name]);
        species=str2num(dd(ii).name(2:3));
        gl=str2num(dd(ii).name(5:6));
        n = reshape(nin,fgrid(gl).Nx,fgrid(gl).Ny,fgrid(gl).Nz);
        fgrid(gl).particle(species).n=n;
        % save both E and B in the grid file below. And j and n too.
       otherwise
        disp(['Nothing to do for file ' dd(ii).name])

      end
    end
  end
end
eval(['save -v7 outp/grid.cheese.mat fgrid'])

% Now we delete all the files we used for the grid
filepath='outp/datfiles/Efield/';
dd=dir(filepath);
for ii=1:length(dd)
  if length(dd(ii).name)>14
    if strcmp(dd(ii).name(end-10:end),'.cheese.dat')
      delete([filepath dd(ii).name]);
    end
  end
end
filepath='outp/datfiles/Bfield/';
dd=dir(filepath);
for ii=1:length(dd)
  if length(dd(ii).name)>14
    if strcmp(dd(ii).name(end-10:end),'.cheese.dat')
      delete([filepath dd(ii).name]);
    end
  end
end
filepath='outp/datfiles/current/';
dd=dir(filepath);
for ii=1:length(dd)
  if length(dd(ii).name)>14
    if strcmp(dd(ii).name(end-10:end),'.cheese.dat')
      delete([filepath dd(ii).name]);
    end
  end
end
filepath='outp/datfiles/density/';
dd=dir(filepath);
for ii=1:length(dd)
  if length(dd(ii).name)>14
    if strcmp(dd(ii).name(end-10:end),'.cheese.dat')
      delete([filepath dd(ii).name]);
    end
  end
end

% Distribution function probes
filepath='outp/datfiles/statistics/';
dd=dir(filepath);
startfiles=[];
for ii=3:length(dd)
  if length(dd(ii).name)>14
    if strcmp(dd(ii).name(end-10:end),'.cheese.dat')
      if strcmp(dd(ii).name(1:2),'fp')
        if strcmp(dd(ii).name(3:4),'01')
          startfiles = [startfiles ii];
        end
      end
    end
  end
end
for ii=startfiles
  % If not all files exist, that is an error.
  infilesexistnot = logical(zeros(1,Nprobes));
  for jj = 1:Nprobes
    infilesexistnot(jj) = ...
        ~exist([filepath 'fp' num2str(jj,'%0.2d') dd(ii).name(5:end)]);
  end
  if sum(infilesexistnot)>0
    error(['fp: infilesexistnot=',num2str(infilesexistnot)])
  end
  % Now that we know the files exist, we read them
  for jj = 1:Nprobes
    fin = load([filepath 'fp' num2str(jj,'%0.2d') dd(ii).name(5:end)]);
    probe(jj).f=reshape(fin,probe(jj).Nvx,probe(jj).Nvy,probe(jj).Nvz);
  end
  eval(['save -v7 outp/fp' dd(ii).name(6:15) '.cheese.mat probe'])
  delete([filepath dd(ii).name(1:2) '*' dd(ii).name(5:end)]);

end
