% cheese_a3convtestp converts output files from cheese and related programs to
% matlab's own data format.
%
% This is a reduced version that only converts the test particle related
% files. For the complete conversion version, use cheese_a3conv.
% 
% HG 2014-06-20

inputcheese

% Now read the probe specific data, if there are probes that is.
probe=struct();
fid=fopen('inputcheese.m');
for ii=1:Nprobes
  theline=fgetl(fid);
  if length(theline)<5,
    theline=[theline '     '];
  end
  while ~(strcmp(theline(1:5),'%PROB') | strcmp(theline(1:5),'%prob'))
    theline=fgetl(fid);
    if length(theline)<5,
      theline=[theline '     '];
    end
  end
  while ~(strcmp(theline(1:4),'%END') | strcmp(theline(1:4),'%end'))
    eval(theline)
    theline=fgetl(fid);
    if length(theline)<4,
      theline=[theline '    '];
    end
  end
  probe(ii).Nvx=Nvx;
  probe(ii).Nvy=Nvy;
  probe(ii).Nvz=Nvz;
  probe(ii).vxmin=vxmin;
  probe(ii).vxmax=vxmax;
  probe(ii).vymin=vymin;
  probe(ii).vymax=vymax;
  probe(ii).vzmin=vzmin;
  probe(ii).vzmax=vzmax;
  probe(ii).xc=xc;
  probe(ii).yc=yc;
  probe(ii).zc=zc;
  probe(ii).rprobe=rprobe;
  
  probe(ii).dvx = (vxmax-vxmin)/(Nvx-1);
  probe(ii).dvy = (vymax-vymin)/(Nvy-1);
  probe(ii).dvz = (vzmax-vzmin)/(Nvz-1);
  probe(ii).vx  = vxmin + probe(ii).dvx*[0:Nvx-1];
  probe(ii).vy  = vymin + probe(ii).dvy*[0:Nvy-1];
  probe(ii).vz  = vzmin + probe(ii).dvz*[0:Nvz-1];
end
fclose(fid);

% Hybrid species parameters
particle=struct();
fid=fopen('inputcheese.m');
for ii=1:NhybSpecies
  theline=fgetl(fid);
  if length(theline)<5,
    theline=[theline '     '];
  end
  while ~(strcmp(theline(1:5),'%SPEC') | strcmp(theline(1:5),'%spec'))
    theline=fgetl(fid);
    if length(theline)<5,
      theline=[theline '     '];
    end
  end
  while ~(strcmp(theline(1:4),'%END') | strcmp(theline(1:4),'%end'))
    eval(theline)
    theline=fgetl(fid);
    if length(theline)<4,
      theline=[theline '    '];
    end
  end
  particle(ii).hybfilename = hybfilename;
  particle(ii).chargestate = chargestate;
  particle(ii).hybiteration =hybiteration;
end
fclose(fid);

% Parameters of the grid that is used for statistical output
fid=fopen('inputcheese.m');
theline=fgetl(fid);
if length(theline)<5,
  theline=[theline '     '];
end
while ~(strcmp(theline(1:5),'%PARA') | strcmp(theline(1:5),'%para'))
  theline=fgetl(fid);
  if length(theline)<5,
    theline=[theline '     '];
  end
end
while ~(strcmp(theline(1:4),'%END') | strcmp(theline(1:4),'%end'))
  eval(theline)
  theline=fgetl(fid);
  if length(theline)<4,
    theline=[theline '    '];
  end
end
Lx=xmax-xmin;
Ly=ymax-ymin;
Lz=zmax-zmin;
dx = Lx/(Nx-1);
dy = Ly/(Ny-1);
dz = Lz/(Nz-1);
x = xmin + dx*[0:Nx-1];
y = ymin + dy*[0:Ny-1];
z = zmin + dz*[0:Nz-1];
fclose(fid);
filepath='outp/datfiles/statistics/';
dd=dir(filepath);
for ii=1:length(dd)
  if length(dd(ii).name)>14
    if strcmp(dd(ii).name(end-10:end),'.cheese.dat')
      if strcmp(dd(ii).name(1:4),'dens')
        nin = load([filepath dd(ii).name]);
        n = reshape(nin,Nx,Ny,Nz);
        eval(['save -v7 outp/testpdens' dd(ii).name(5:14) '.cheese.mat n ' ...
              'Nx Ny Nz Lx Ly Lz x y z dx dy dz'])
        delete([filepath dd(ii).name]);
      end
    end
  end
end


% Read the input grids here
fgrid=struct();
fid=fopen('inputcheese.m');
for ii=1:Ngridlevels
  theline=fgetl(fid);
  if length(theline)<5,
    theline=[theline '     '];
  end
  while ~(strcmp(theline(1:5),'%GRID') | strcmp(theline(1:5),'%grid'))
    theline=fgetl(fid);
    if length(theline)<5,
      theline=[theline '     '];
    end
  end
  while ~(strcmp(theline(1:4),'%END') | strcmp(theline(1:4),'%end'))
    eval(theline)
    theline=fgetl(fid);
    if length(theline)<4,
      theline=[theline '    '];
    end
  end
  fgrid(ii).Nx=Nx;
  fgrid(ii).Ny=Ny;
  fgrid(ii).Nz=Nz;
  fgrid(ii).xmin=xmin;
  fgrid(ii).xmax=xmax;
  fgrid(ii).ymin=ymin;
  fgrid(ii).ymax=ymax;
  fgrid(ii).zmin=zmin;
  fgrid(ii).zmax=zmax;
  
  fgrid(ii).Lx=fgrid(ii).xmax-fgrid(ii).xmin;
  fgrid(ii).Ly=fgrid(ii).ymax-fgrid(ii).ymin;
  fgrid(ii).Lz=fgrid(ii).zmax-fgrid(ii).zmin;
  fgrid(ii).dx = fgrid(ii).Lx/(fgrid(ii).Nx-1);
  fgrid(ii).dy = fgrid(ii).Ly/(fgrid(ii).Ny-1);
  fgrid(ii).dz = fgrid(ii).Lz/(fgrid(ii).Nz-1);
  fgrid(ii).x = fgrid(ii).xmin + fgrid(ii).dx*[0:fgrid(ii).Nx-1];
  fgrid(ii).y = fgrid(ii).ymin + fgrid(ii).dy*[0:fgrid(ii).Ny-1];
  fgrid(ii).z = fgrid(ii).zmin + fgrid(ii).dz*[0:fgrid(ii).Nz-1];
end
fclose(fid);


% Distribution function probes
filepath='outp/datfiles/statistics/';
dd=dir(filepath);
startfiles=[];
for ii=3:length(dd)
  if length(dd(ii).name)>14
    if strcmp(dd(ii).name(end-10:end),'.cheese.dat')
      if strcmp(dd(ii).name(1:2),'fp')
        if strcmp(dd(ii).name(3:4),'01')
          startfiles = [startfiles ii];
        end
      end
    end
  end
end
for ii=startfiles
  % If not all files exist, that is an error.
  infilesexistnot = logical(zeros(1,Nprobes));
  for jj = 1:Nprobes
    infilesexistnot(jj) = ...
        ~exist([filepath 'fp' num2str(jj,'%0.2d') dd(ii).name(5:end)]);
  end
  if sum(infilesexistnot)>0
    error(['fp: infilesexistnot=',num2str(infilesexistnot)])
  end
  % Now that we know the files exist, we read them
  for jj = 1:Nprobes
    fin = load([filepath 'fp' num2str(jj,'%0.2d') dd(ii).name(5:end)]);
    probe(jj).f=reshape(fin,probe(jj).Nvx,probe(jj).Nvy,probe(jj).Nvz);
  end
  eval(['save -v7 outp/fp' dd(ii).name(6:15) '.cheese.mat probe'])
  delete([filepath dd(ii).name(1:2) '*' dd(ii).name(5:end)]);

end
