% cheese_a3pss15Efielddir plots the E-field direction for use in the PSS
% paper in 2015.
%
% HG 2015-08-09


inputcheese;

z1=0;y1=0;gl=3;

% Assemble filenames


% Load fields
load('outp/grid.cheese.mat');

Nmidy=floor((y1-fgrid(gl).ymin)/fgrid(gl).dy+1);% round downward, then
if abs(fgrid(gl).y(Nmidy)-y1)>fgrid(gl).dy*0.1  % take mean of this and
  Nmidyvec = [Nmidy:Nmidy+1];                   % one higher, unless
else                                            % there is a point at y1
  Nmidyvec = Nmidy;                             % or z1 in which case we
end                                             % use that point

figure(80002)
clf
set(gcf,'paperpositionmode','auto','position',[5 471 410 500])
gl=3;
ppEx=[];ppEx(:,:)=mean(fgrid(gl).Ex(:,Nmidyvec,:),2);
ppEz=[];ppEz(:,:)=mean(fgrid(gl).Ez(:,Nmidyvec,:),2);
xplot=[fgrid(gl).x]*1e-3;
zplot=[fgrid(gl).z]*1e-3;
xstart=[-3:3]*1e3;
zstart=zeros(size(xstart));
hstru3=streamline(xplot,zplot,ppEx,ppEz,xstart,zstart);
hstrd3=streamline(xplot,zplot,-ppEx,-ppEz,xstart,zstart);
set(hstru3,'color','k')
set(hstrd3,'color','k')


gl=2;
Nmidy=floor((y1-fgrid(gl).ymin)/fgrid(gl).dy+1);% round downward, then
if abs(fgrid(gl).y(Nmidy)-y1)>fgrid(gl).dy*0.1  % take mean of this and
  Nmidyvec = [Nmidy:Nmidy+1];                   % one higher, unless
else                                            % there is a point at y1
  Nmidyvec = Nmidy;                             % or z1 in which case we
end                                             % use that point

ppEx=[];ppEx(:,:)=mean(fgrid(gl).Ex(:,Nmidyvec,:),2);
ppEz=[];ppEz(:,:)=mean(fgrid(gl).Ez(:,Nmidyvec,:),2);
xplot=[fgrid(gl).x]*1e-3;
zplot=[fgrid(gl).z]*1e-3;
xstartu=[-4000 -3000 -3012 -2843 -2059 -253.4 1070 2201];
zstartu=[    0     0  1210  2999  3010 2996   2996 2996];
xstartd=[-4000 -2161 -1913  -924.6    51.03  904.8  1305  3025];
zstartd=[    0 -3026 -3026 -3026   -3026    -3026  -3026  -121];
hstru2=streamline(xplot,zplot,ppEx,ppEz,xstartu,zstartu);
hstrd2=streamline(xplot,zplot,-ppEx,-ppEz,xstartd,zstartd);
set(hstru2,'color','k')
set(hstrd2,'color','k')

axis equal
axis([-4500 3500 -6000 6000])
hold on
aa=axis;
plot(aa(1:2),[0 0],'k--')
plot([0 0],aa(3:4),'k--')

z0=-4313+1i*3994;d=-7+1i*61;
pil(z0,d,500,'k');

z0=-3622+1i*3994;d=-7+1i*60;
pil(z0,d,500,'k');

z0=-3000+1i*3967;d=-7+1i*61;
pil(z0,d,500,'k');

z0=-2226+1i*3978;d=-8+1i*61;
pil(z0,d,500,'k');

z0=-419.3+1i*3964;d=-8.4+1i*61;
pil(z0,d,500,'k');

z0=899.5+1i*3964;d=-9.3+1i*61;
pil(z0,d,500,'k');

z0=2012+1i*3964;d=-10+1i*61;
pil(z0,d,500,'k');

hold off

set(gca,'fontname','times','fontsize',14)
xlabel('x   [km]','fontname','times','fontsize',18)
ylabel('z   [km]','fontname','times','fontsize',18)


if 3==4
  ccc=pwd;
  cd ~
  print -f80002 -depsc2 fig-Efielddir.eps
  cd(ccc)
end
