function z=pil(z0,d,l,c,ce)
% PIL plots an arrowhead on the current figure
% 
% Z=PIL(z0,d,l,c,ce) draws an arrowhead with its tip at z0, directed in the d
% direction with length l and colour c. If c='none' nothing is drawn. 
% The coordinates of the arrowhead corners are returned in Z.
% 
% The ce argument enables the specification of an edgecolour for the
% arrow. If not specified, ce becomes equal to c. This makes the
% behaviour of the function different from what it was before 120906,
% where the edgecolour always was black.
%
% z0 and d are complex numbers, and so is Z.
%
%        120906 040528

if nargin<5
  ce=c;
end
  
% normalise
dn=d/abs(d);


z=[(z0-dn*l*(1+0.22i)) z0 (z0-dn*l*(1-0.22i))];

if ~strcmp(c,'none')
  fill(real(z),imag(z),c,'edgecolor',ce)
end % end if ~strcmp(c,'none')

